/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.CatalinaObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;
import org.objectweb.jonas.webapp.jonasadmin.security.RealmItem;
import org.objectweb.jonas.webapp.jonasadmin.security.RealmItemByNameComparator;

/**
 * @author Michel-Ange ANTON
 */

public class EditServiceSecurityAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER) + WhereAreYou.NODE_SEPARATOR
            + "services" + WhereAreYou.NODE_SEPARATOR + "security", true);

        // Current server
        WhereAreYou oWhere = (WhereAreYou) p_Request.getSession().getAttribute(WhereAreYou.
                SESSION_NAME);
        String sServerName = oWhere.getCurrentJonasServerName();

        try {
            ArrayList al = new ArrayList();
            // Catalina
            if (m_WhereAreYou.isCatalinaServer() == true) {
                try {
                    ObjectName on;
                    // Find used realm name
                    on = CatalinaObjectName.catalinaRealm(m_WhereAreYou.
                        getCurrentCatalinaDomainName());
                    String sUsedRealmName = getStringAttribute(on, "resourceName");
                    // Find all realms
                    String sRealmName;
                    String sRealmType;
                    String sPathContext = null;
                    Iterator it = JonasAdminJmx.getListMbean(CatalinaObjectName.catalinaRealms(), sServerName).
                        iterator();
                    while (it.hasNext() == true) {
                        on = (ObjectName) it.next();
                        sRealmName = getStringAttribute(on, "resourceName");
                        sRealmType = JonasAdminJmx.findSecurityFactorySubType(sRealmName, sServerName);
                        try {
                            sPathContext = on.getKeyProperty("path");
                        } catch (NullPointerException e) {
                            // Not possible as "path" is not null
                        }
                        if (sPathContext != null) {
                            al.add(new RealmItem(sRealmName, sRealmType, sPathContext
                            , sRealmName.equals(sUsedRealmName)));
                        }
                    }
                    // Sort
                    Collections.sort(al, new RealmItemByNameComparator());
                }
                catch (Exception e) {
                    // no action
                    // Exception because catalina realm don't exists
                }
            }
            // Set form in the request
            p_Request.setAttribute("listSecurityRealms", al);
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("Service Security"));
    }
}
